﻿#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;



[global::System.Data.Linq.Mapping.DatabaseAttribute(Name="db_webapp")]
public partial class DatabaseDataContext : System.Data.Linq.DataContext
{
	
	private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
	
  #region Extensibility Method Definitions
  partial void OnCreated();
  partial void InsertCustomer(Customer instance);
  partial void UpdateCustomer(Customer instance);
  partial void DeleteCustomer(Customer instance);
  partial void InsertUser(User instance);
  partial void UpdateUser(User instance);
  partial void DeleteUser(User instance);
  partial void InsertProduct(Product instance);
  partial void UpdateProduct(Product instance);
  partial void DeleteProduct(Product instance);
  partial void InsertProductDetail(ProductDetail instance);
  partial void UpdateProductDetail(ProductDetail instance);
  partial void DeleteProductDetail(ProductDetail instance);
  partial void InsertTransaction(Transaction instance);
  partial void UpdateTransaction(Transaction instance);
  partial void DeleteTransaction(Transaction instance);
  partial void InsertTransactionDetail(TransactionDetail instance);
  partial void UpdateTransactionDetail(TransactionDetail instance);
  partial void DeleteTransactionDetail(TransactionDetail instance);
  #endregion
	
	public DatabaseDataContext() : 
			base(global::System.Configuration.ConfigurationManager.ConnectionStrings["db_webappConnectionString"].ConnectionString, mappingSource)
	{
		OnCreated();
	}
	
	public DatabaseDataContext(string connection) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public DatabaseDataContext(System.Data.IDbConnection connection) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public DatabaseDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public DatabaseDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public System.Data.Linq.Table<Customer> Customers
	{
		get
		{
			return this.GetTable<Customer>();
		}
	}
	
	public System.Data.Linq.Table<User> Users
	{
		get
		{
			return this.GetTable<User>();
		}
	}
	
	public System.Data.Linq.Table<Product> Products
	{
		get
		{
			return this.GetTable<Product>();
		}
	}
	
	public System.Data.Linq.Table<ProductDetail> ProductDetails
	{
		get
		{
			return this.GetTable<ProductDetail>();
		}
	}
	
	public System.Data.Linq.Table<Transaction> Transactions
	{
		get
		{
			return this.GetTable<Transaction>();
		}
	}
	
	public System.Data.Linq.Table<TransactionDetail> TransactionDetails
	{
		get
		{
			return this.GetTable<TransactionDetail>();
		}
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Customer")]
public partial class Customer : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDCustomer;
	
	private string _Name;
	
	private System.Nullable<bool> _Flag;
	
	private string _CreatedBy;
	
	private System.Nullable<System.DateTime> _CreatedAt;
	
	private EntitySet<Transaction> _Transactions;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDCustomerChanging(int value);
    partial void OnIDCustomerChanged();
    partial void OnNameChanging(string value);
    partial void OnNameChanged();
    partial void OnFlagChanging(System.Nullable<bool> value);
    partial void OnFlagChanged();
    partial void OnCreatedByChanging(string value);
    partial void OnCreatedByChanged();
    partial void OnCreatedAtChanging(System.Nullable<System.DateTime> value);
    partial void OnCreatedAtChanged();
    #endregion
	
	public Customer()
	{
		this._Transactions = new EntitySet<Transaction>(new Action<Transaction>(this.attach_Transactions), new Action<Transaction>(this.detach_Transactions));
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDCustomer", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDCustomer
	{
		get
		{
			return this._IDCustomer;
		}
		set
		{
			if ((this._IDCustomer != value))
			{
				this.OnIDCustomerChanging(value);
				this.SendPropertyChanging();
				this._IDCustomer = value;
				this.SendPropertyChanged("IDCustomer");
				this.OnIDCustomerChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(50)")]
	public string Name
	{
		get
		{
			return this._Name;
		}
		set
		{
			if ((this._Name != value))
			{
				this.OnNameChanging(value);
				this.SendPropertyChanging();
				this._Name = value;
				this.SendPropertyChanged("Name");
				this.OnNameChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Flag", DbType="Bit")]
	public System.Nullable<bool> Flag
	{
		get
		{
			return this._Flag;
		}
		set
		{
			if ((this._Flag != value))
			{
				this.OnFlagChanging(value);
				this.SendPropertyChanging();
				this._Flag = value;
				this.SendPropertyChanged("Flag");
				this.OnFlagChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedBy", DbType="VarChar(50)")]
	public string CreatedBy
	{
		get
		{
			return this._CreatedBy;
		}
		set
		{
			if ((this._CreatedBy != value))
			{
				this.OnCreatedByChanging(value);
				this.SendPropertyChanging();
				this._CreatedBy = value;
				this.SendPropertyChanged("CreatedBy");
				this.OnCreatedByChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedAt", DbType="DateTime")]
	public System.Nullable<System.DateTime> CreatedAt
	{
		get
		{
			return this._CreatedAt;
		}
		set
		{
			if ((this._CreatedAt != value))
			{
				this.OnCreatedAtChanging(value);
				this.SendPropertyChanging();
				this._CreatedAt = value;
				this.SendPropertyChanged("CreatedAt");
				this.OnCreatedAtChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Customer_Transaction", Storage="_Transactions", ThisKey="IDCustomer", OtherKey="IDCustomer")]
	public EntitySet<Transaction> Transactions
	{
		get
		{
			return this._Transactions;
		}
		set
		{
			this._Transactions.Assign(value);
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_Transactions(Transaction entity)
	{
		this.SendPropertyChanging();
		entity.Customer = this;
	}
	
	private void detach_Transactions(Transaction entity)
	{
		this.SendPropertyChanging();
		entity.Customer = null;
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.[User]")]
public partial class User : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDUser;
	
	private string _Name;
	
	private string _Username;
	
	private string _Password;
	
	private System.Nullable<bool> _Flag;
	
	private string _CreatedBy;
	
	private System.Nullable<System.DateTime> _CreatedAt;
	
	private EntitySet<Transaction> _Transactions;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDUserChanging(int value);
    partial void OnIDUserChanged();
    partial void OnNameChanging(string value);
    partial void OnNameChanged();
    partial void OnUsernameChanging(string value);
    partial void OnUsernameChanged();
    partial void OnPasswordChanging(string value);
    partial void OnPasswordChanged();
    partial void OnFlagChanging(System.Nullable<bool> value);
    partial void OnFlagChanged();
    partial void OnCreatedByChanging(string value);
    partial void OnCreatedByChanged();
    partial void OnCreatedAtChanging(System.Nullable<System.DateTime> value);
    partial void OnCreatedAtChanged();
    #endregion
	
	public User()
	{
		this._Transactions = new EntitySet<Transaction>(new Action<Transaction>(this.attach_Transactions), new Action<Transaction>(this.detach_Transactions));
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDUser", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDUser
	{
		get
		{
			return this._IDUser;
		}
		set
		{
			if ((this._IDUser != value))
			{
				this.OnIDUserChanging(value);
				this.SendPropertyChanging();
				this._IDUser = value;
				this.SendPropertyChanged("IDUser");
				this.OnIDUserChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(50)")]
	public string Name
	{
		get
		{
			return this._Name;
		}
		set
		{
			if ((this._Name != value))
			{
				this.OnNameChanging(value);
				this.SendPropertyChanging();
				this._Name = value;
				this.SendPropertyChanged("Name");
				this.OnNameChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Username", DbType="VarChar(50)")]
	public string Username
	{
		get
		{
			return this._Username;
		}
		set
		{
			if ((this._Username != value))
			{
				this.OnUsernameChanging(value);
				this.SendPropertyChanging();
				this._Username = value;
				this.SendPropertyChanged("Username");
				this.OnUsernameChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Password", DbType="VarChar(50)")]
	public string Password
	{
		get
		{
			return this._Password;
		}
		set
		{
			if ((this._Password != value))
			{
				this.OnPasswordChanging(value);
				this.SendPropertyChanging();
				this._Password = value;
				this.SendPropertyChanged("Password");
				this.OnPasswordChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Flag", DbType="Bit")]
	public System.Nullable<bool> Flag
	{
		get
		{
			return this._Flag;
		}
		set
		{
			if ((this._Flag != value))
			{
				this.OnFlagChanging(value);
				this.SendPropertyChanging();
				this._Flag = value;
				this.SendPropertyChanged("Flag");
				this.OnFlagChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedBy", DbType="VarChar(50)")]
	public string CreatedBy
	{
		get
		{
			return this._CreatedBy;
		}
		set
		{
			if ((this._CreatedBy != value))
			{
				this.OnCreatedByChanging(value);
				this.SendPropertyChanging();
				this._CreatedBy = value;
				this.SendPropertyChanged("CreatedBy");
				this.OnCreatedByChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedAt", DbType="DateTime")]
	public System.Nullable<System.DateTime> CreatedAt
	{
		get
		{
			return this._CreatedAt;
		}
		set
		{
			if ((this._CreatedAt != value))
			{
				this.OnCreatedAtChanging(value);
				this.SendPropertyChanging();
				this._CreatedAt = value;
				this.SendPropertyChanged("CreatedAt");
				this.OnCreatedAtChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="User_Transaction", Storage="_Transactions", ThisKey="IDUser", OtherKey="IDUser")]
	public EntitySet<Transaction> Transactions
	{
		get
		{
			return this._Transactions;
		}
		set
		{
			this._Transactions.Assign(value);
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_Transactions(Transaction entity)
	{
		this.SendPropertyChanging();
		entity.User = this;
	}
	
	private void detach_Transactions(Transaction entity)
	{
		this.SendPropertyChanging();
		entity.User = null;
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.Product")]
public partial class Product : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDProduct;
	
	private string _SKU;
	
	private string _Name;
	
	private System.Nullable<bool> _Flag;
	
	private string _CreatedBy;
	
	private System.Nullable<System.DateTime> _CreatedAt;
	
	private EntitySet<ProductDetail> _ProductDetails;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDProductChanging(int value);
    partial void OnIDProductChanged();
    partial void OnSKUChanging(string value);
    partial void OnSKUChanged();
    partial void OnNameChanging(string value);
    partial void OnNameChanged();
    partial void OnFlagChanging(System.Nullable<bool> value);
    partial void OnFlagChanged();
    partial void OnCreatedByChanging(string value);
    partial void OnCreatedByChanged();
    partial void OnCreatedAtChanging(System.Nullable<System.DateTime> value);
    partial void OnCreatedAtChanged();
    #endregion
	
	public Product()
	{
		this._ProductDetails = new EntitySet<ProductDetail>(new Action<ProductDetail>(this.attach_ProductDetails), new Action<ProductDetail>(this.detach_ProductDetails));
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDProduct", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDProduct
	{
		get
		{
			return this._IDProduct;
		}
		set
		{
			if ((this._IDProduct != value))
			{
				this.OnIDProductChanging(value);
				this.SendPropertyChanging();
				this._IDProduct = value;
				this.SendPropertyChanged("IDProduct");
				this.OnIDProductChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SKU", DbType="VarChar(50)")]
	public string SKU
	{
		get
		{
			return this._SKU;
		}
		set
		{
			if ((this._SKU != value))
			{
				this.OnSKUChanging(value);
				this.SendPropertyChanging();
				this._SKU = value;
				this.SendPropertyChanged("SKU");
				this.OnSKUChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(50)")]
	public string Name
	{
		get
		{
			return this._Name;
		}
		set
		{
			if ((this._Name != value))
			{
				this.OnNameChanging(value);
				this.SendPropertyChanging();
				this._Name = value;
				this.SendPropertyChanged("Name");
				this.OnNameChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Flag", DbType="Bit")]
	public System.Nullable<bool> Flag
	{
		get
		{
			return this._Flag;
		}
		set
		{
			if ((this._Flag != value))
			{
				this.OnFlagChanging(value);
				this.SendPropertyChanging();
				this._Flag = value;
				this.SendPropertyChanged("Flag");
				this.OnFlagChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedBy", DbType="VarChar(50)")]
	public string CreatedBy
	{
		get
		{
			return this._CreatedBy;
		}
		set
		{
			if ((this._CreatedBy != value))
			{
				this.OnCreatedByChanging(value);
				this.SendPropertyChanging();
				this._CreatedBy = value;
				this.SendPropertyChanged("CreatedBy");
				this.OnCreatedByChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedAt", DbType="DateTime")]
	public System.Nullable<System.DateTime> CreatedAt
	{
		get
		{
			return this._CreatedAt;
		}
		set
		{
			if ((this._CreatedAt != value))
			{
				this.OnCreatedAtChanging(value);
				this.SendPropertyChanging();
				this._CreatedAt = value;
				this.SendPropertyChanged("CreatedAt");
				this.OnCreatedAtChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Product_ProductDetail", Storage="_ProductDetails", ThisKey="IDProduct", OtherKey="IDProduct")]
	public EntitySet<ProductDetail> ProductDetails
	{
		get
		{
			return this._ProductDetails;
		}
		set
		{
			this._ProductDetails.Assign(value);
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_ProductDetails(ProductDetail entity)
	{
		this.SendPropertyChanging();
		entity.Product = this;
	}
	
	private void detach_ProductDetails(ProductDetail entity)
	{
		this.SendPropertyChanging();
		entity.Product = null;
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.ProductDetail")]
public partial class ProductDetail : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDProductDetails;
	
	private System.Nullable<int> _IDProduct;
	
	private string _Variant;
	
	private System.Nullable<int> _Qty;
	
	private System.Nullable<int> _Price;
	
	private System.Nullable<bool> _Flag;
	
	private string _CreatedBy;
	
	private System.Nullable<System.DateTime> _CreatedAt;
	
	private EntitySet<TransactionDetail> _TransactionDetails;
	
	private EntityRef<Product> _Product;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDProductDetailsChanging(int value);
    partial void OnIDProductDetailsChanged();
    partial void OnIDProductChanging(System.Nullable<int> value);
    partial void OnIDProductChanged();
    partial void OnVariantChanging(string value);
    partial void OnVariantChanged();
    partial void OnQtyChanging(System.Nullable<int> value);
    partial void OnQtyChanged();
    partial void OnPriceChanging(System.Nullable<int> value);
    partial void OnPriceChanged();
    partial void OnFlagChanging(System.Nullable<bool> value);
    partial void OnFlagChanged();
    partial void OnCreatedByChanging(string value);
    partial void OnCreatedByChanged();
    partial void OnCreatedAtChanging(System.Nullable<System.DateTime> value);
    partial void OnCreatedAtChanged();
    #endregion
	
	public ProductDetail()
	{
		this._TransactionDetails = new EntitySet<TransactionDetail>(new Action<TransactionDetail>(this.attach_TransactionDetails), new Action<TransactionDetail>(this.detach_TransactionDetails));
		this._Product = default(EntityRef<Product>);
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDProductDetails", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDProductDetails
	{
		get
		{
			return this._IDProductDetails;
		}
		set
		{
			if ((this._IDProductDetails != value))
			{
				this.OnIDProductDetailsChanging(value);
				this.SendPropertyChanging();
				this._IDProductDetails = value;
				this.SendPropertyChanged("IDProductDetails");
				this.OnIDProductDetailsChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDProduct", DbType="Int")]
	public System.Nullable<int> IDProduct
	{
		get
		{
			return this._IDProduct;
		}
		set
		{
			if ((this._IDProduct != value))
			{
				if (this._Product.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.OnIDProductChanging(value);
				this.SendPropertyChanging();
				this._IDProduct = value;
				this.SendPropertyChanged("IDProduct");
				this.OnIDProductChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Variant", DbType="VarChar(50)")]
	public string Variant
	{
		get
		{
			return this._Variant;
		}
		set
		{
			if ((this._Variant != value))
			{
				this.OnVariantChanging(value);
				this.SendPropertyChanging();
				this._Variant = value;
				this.SendPropertyChanged("Variant");
				this.OnVariantChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Qty", DbType="Int")]
	public System.Nullable<int> Qty
	{
		get
		{
			return this._Qty;
		}
		set
		{
			if ((this._Qty != value))
			{
				this.OnQtyChanging(value);
				this.SendPropertyChanging();
				this._Qty = value;
				this.SendPropertyChanged("Qty");
				this.OnQtyChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Price", DbType="Int")]
	public System.Nullable<int> Price
	{
		get
		{
			return this._Price;
		}
		set
		{
			if ((this._Price != value))
			{
				this.OnPriceChanging(value);
				this.SendPropertyChanging();
				this._Price = value;
				this.SendPropertyChanged("Price");
				this.OnPriceChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Flag", DbType="Bit")]
	public System.Nullable<bool> Flag
	{
		get
		{
			return this._Flag;
		}
		set
		{
			if ((this._Flag != value))
			{
				this.OnFlagChanging(value);
				this.SendPropertyChanging();
				this._Flag = value;
				this.SendPropertyChanged("Flag");
				this.OnFlagChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedBy", DbType="VarChar(50)")]
	public string CreatedBy
	{
		get
		{
			return this._CreatedBy;
		}
		set
		{
			if ((this._CreatedBy != value))
			{
				this.OnCreatedByChanging(value);
				this.SendPropertyChanging();
				this._CreatedBy = value;
				this.SendPropertyChanged("CreatedBy");
				this.OnCreatedByChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreatedAt", DbType="DateTime")]
	public System.Nullable<System.DateTime> CreatedAt
	{
		get
		{
			return this._CreatedAt;
		}
		set
		{
			if ((this._CreatedAt != value))
			{
				this.OnCreatedAtChanging(value);
				this.SendPropertyChanging();
				this._CreatedAt = value;
				this.SendPropertyChanged("CreatedAt");
				this.OnCreatedAtChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="ProductDetail_TransactionDetail", Storage="_TransactionDetails", ThisKey="IDProductDetails", OtherKey="IDProductDetails")]
	public EntitySet<TransactionDetail> TransactionDetails
	{
		get
		{
			return this._TransactionDetails;
		}
		set
		{
			this._TransactionDetails.Assign(value);
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Product_ProductDetail", Storage="_Product", ThisKey="IDProduct", OtherKey="IDProduct", IsForeignKey=true)]
	public Product Product
	{
		get
		{
			return this._Product.Entity;
		}
		set
		{
			Product previousValue = this._Product.Entity;
			if (((previousValue != value) 
						|| (this._Product.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._Product.Entity = null;
					previousValue.ProductDetails.Remove(this);
				}
				this._Product.Entity = value;
				if ((value != null))
				{
					value.ProductDetails.Add(this);
					this._IDProduct = value.IDProduct;
				}
				else
				{
					this._IDProduct = default(Nullable<int>);
				}
				this.SendPropertyChanged("Product");
			}
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_TransactionDetails(TransactionDetail entity)
	{
		this.SendPropertyChanging();
		entity.ProductDetail = this;
	}
	
	private void detach_TransactionDetails(TransactionDetail entity)
	{
		this.SendPropertyChanging();
		entity.ProductDetail = null;
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.[Transaction]")]
public partial class Transaction : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDTransaction;
	
	private System.Nullable<System.DateTime> _Date;
	
	private System.Nullable<int> _IDUser;
	
	private System.Nullable<int> _IDCustomer;
	
	private System.Nullable<int> _Discount;
	
	private System.Nullable<int> _Subtotal;
	
	private System.Nullable<int> _Grandtotal;
	
	private string _CreateBy;
	
	private System.Nullable<System.DateTime> _CreateAt;
	
	private EntitySet<TransactionDetail> _TransactionDetails;
	
	private EntityRef<Customer> _Customer;
	
	private EntityRef<User> _User;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDTransactionChanging(int value);
    partial void OnIDTransactionChanged();
    partial void OnDateChanging(System.Nullable<System.DateTime> value);
    partial void OnDateChanged();
    partial void OnIDUserChanging(System.Nullable<int> value);
    partial void OnIDUserChanged();
    partial void OnIDCustomerChanging(System.Nullable<int> value);
    partial void OnIDCustomerChanged();
    partial void OnDiscountChanging(System.Nullable<int> value);
    partial void OnDiscountChanged();
    partial void OnSubtotalChanging(System.Nullable<int> value);
    partial void OnSubtotalChanged();
    partial void OnGrandtotalChanging(System.Nullable<int> value);
    partial void OnGrandtotalChanged();
    partial void OnCreateByChanging(string value);
    partial void OnCreateByChanged();
    partial void OnCreateAtChanging(System.Nullable<System.DateTime> value);
    partial void OnCreateAtChanged();
    #endregion
	
	public Transaction()
	{
		this._TransactionDetails = new EntitySet<TransactionDetail>(new Action<TransactionDetail>(this.attach_TransactionDetails), new Action<TransactionDetail>(this.detach_TransactionDetails));
		this._Customer = default(EntityRef<Customer>);
		this._User = default(EntityRef<User>);
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDTransaction", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDTransaction
	{
		get
		{
			return this._IDTransaction;
		}
		set
		{
			if ((this._IDTransaction != value))
			{
				this.OnIDTransactionChanging(value);
				this.SendPropertyChanging();
				this._IDTransaction = value;
				this.SendPropertyChanged("IDTransaction");
				this.OnIDTransactionChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Date", DbType="Date")]
	public System.Nullable<System.DateTime> Date
	{
		get
		{
			return this._Date;
		}
		set
		{
			if ((this._Date != value))
			{
				this.OnDateChanging(value);
				this.SendPropertyChanging();
				this._Date = value;
				this.SendPropertyChanged("Date");
				this.OnDateChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDUser", DbType="Int")]
	public System.Nullable<int> IDUser
	{
		get
		{
			return this._IDUser;
		}
		set
		{
			if ((this._IDUser != value))
			{
				if (this._User.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.OnIDUserChanging(value);
				this.SendPropertyChanging();
				this._IDUser = value;
				this.SendPropertyChanged("IDUser");
				this.OnIDUserChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDCustomer", DbType="Int")]
	public System.Nullable<int> IDCustomer
	{
		get
		{
			return this._IDCustomer;
		}
		set
		{
			if ((this._IDCustomer != value))
			{
				if (this._Customer.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.OnIDCustomerChanging(value);
				this.SendPropertyChanging();
				this._IDCustomer = value;
				this.SendPropertyChanged("IDCustomer");
				this.OnIDCustomerChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Discount", DbType="Int")]
	public System.Nullable<int> Discount
	{
		get
		{
			return this._Discount;
		}
		set
		{
			if ((this._Discount != value))
			{
				this.OnDiscountChanging(value);
				this.SendPropertyChanging();
				this._Discount = value;
				this.SendPropertyChanged("Discount");
				this.OnDiscountChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Subtotal", DbType="Int")]
	public System.Nullable<int> Subtotal
	{
		get
		{
			return this._Subtotal;
		}
		set
		{
			if ((this._Subtotal != value))
			{
				this.OnSubtotalChanging(value);
				this.SendPropertyChanging();
				this._Subtotal = value;
				this.SendPropertyChanged("Subtotal");
				this.OnSubtotalChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Grandtotal", DbType="Int")]
	public System.Nullable<int> Grandtotal
	{
		get
		{
			return this._Grandtotal;
		}
		set
		{
			if ((this._Grandtotal != value))
			{
				this.OnGrandtotalChanging(value);
				this.SendPropertyChanging();
				this._Grandtotal = value;
				this.SendPropertyChanged("Grandtotal");
				this.OnGrandtotalChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreateBy", DbType="VarChar(50)")]
	public string CreateBy
	{
		get
		{
			return this._CreateBy;
		}
		set
		{
			if ((this._CreateBy != value))
			{
				this.OnCreateByChanging(value);
				this.SendPropertyChanging();
				this._CreateBy = value;
				this.SendPropertyChanged("CreateBy");
				this.OnCreateByChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CreateAt", DbType="DateTime")]
	public System.Nullable<System.DateTime> CreateAt
	{
		get
		{
			return this._CreateAt;
		}
		set
		{
			if ((this._CreateAt != value))
			{
				this.OnCreateAtChanging(value);
				this.SendPropertyChanging();
				this._CreateAt = value;
				this.SendPropertyChanged("CreateAt");
				this.OnCreateAtChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Transaction_TransactionDetail", Storage="_TransactionDetails", ThisKey="IDTransaction", OtherKey="IDTransaction")]
	public EntitySet<TransactionDetail> TransactionDetails
	{
		get
		{
			return this._TransactionDetails;
		}
		set
		{
			this._TransactionDetails.Assign(value);
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Customer_Transaction", Storage="_Customer", ThisKey="IDCustomer", OtherKey="IDCustomer", IsForeignKey=true)]
	public Customer Customer
	{
		get
		{
			return this._Customer.Entity;
		}
		set
		{
			Customer previousValue = this._Customer.Entity;
			if (((previousValue != value) 
						|| (this._Customer.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._Customer.Entity = null;
					previousValue.Transactions.Remove(this);
				}
				this._Customer.Entity = value;
				if ((value != null))
				{
					value.Transactions.Add(this);
					this._IDCustomer = value.IDCustomer;
				}
				else
				{
					this._IDCustomer = default(Nullable<int>);
				}
				this.SendPropertyChanged("Customer");
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="User_Transaction", Storage="_User", ThisKey="IDUser", OtherKey="IDUser", IsForeignKey=true)]
	public User User
	{
		get
		{
			return this._User.Entity;
		}
		set
		{
			User previousValue = this._User.Entity;
			if (((previousValue != value) 
						|| (this._User.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._User.Entity = null;
					previousValue.Transactions.Remove(this);
				}
				this._User.Entity = value;
				if ((value != null))
				{
					value.Transactions.Add(this);
					this._IDUser = value.IDUser;
				}
				else
				{
					this._IDUser = default(Nullable<int>);
				}
				this.SendPropertyChanged("User");
			}
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_TransactionDetails(TransactionDetail entity)
	{
		this.SendPropertyChanging();
		entity.Transaction = this;
	}
	
	private void detach_TransactionDetails(TransactionDetail entity)
	{
		this.SendPropertyChanging();
		entity.Transaction = null;
	}
}

[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.TransactionDetail")]
public partial class TransactionDetail : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _IDTransactionDetail;
	
	private System.Nullable<int> _IDTransaction;
	
	private System.Nullable<int> _IDProductDetails;
	
	private System.Nullable<int> _Qty;
	
	private System.Nullable<int> _Price;
	
	private System.Nullable<int> _Discount;
	
	private System.Nullable<int> _Subtotal;
	
	private EntityRef<ProductDetail> _ProductDetail;
	
	private EntityRef<Transaction> _Transaction;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDTransactionDetailChanging(int value);
    partial void OnIDTransactionDetailChanged();
    partial void OnIDTransactionChanging(System.Nullable<int> value);
    partial void OnIDTransactionChanged();
    partial void OnIDProductDetailsChanging(System.Nullable<int> value);
    partial void OnIDProductDetailsChanged();
    partial void OnQtyChanging(System.Nullable<int> value);
    partial void OnQtyChanged();
    partial void OnPriceChanging(System.Nullable<int> value);
    partial void OnPriceChanged();
    partial void OnDiscountChanging(System.Nullable<int> value);
    partial void OnDiscountChanged();
    partial void OnSubtotalChanging(System.Nullable<int> value);
    partial void OnSubtotalChanged();
    #endregion
	
	public TransactionDetail()
	{
		this._ProductDetail = default(EntityRef<ProductDetail>);
		this._Transaction = default(EntityRef<Transaction>);
		OnCreated();
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDTransactionDetail", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
	public int IDTransactionDetail
	{
		get
		{
			return this._IDTransactionDetail;
		}
		set
		{
			if ((this._IDTransactionDetail != value))
			{
				this.OnIDTransactionDetailChanging(value);
				this.SendPropertyChanging();
				this._IDTransactionDetail = value;
				this.SendPropertyChanged("IDTransactionDetail");
				this.OnIDTransactionDetailChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDTransaction", DbType="Int")]
	public System.Nullable<int> IDTransaction
	{
		get
		{
			return this._IDTransaction;
		}
		set
		{
			if ((this._IDTransaction != value))
			{
				if (this._Transaction.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.OnIDTransactionChanging(value);
				this.SendPropertyChanging();
				this._IDTransaction = value;
				this.SendPropertyChanged("IDTransaction");
				this.OnIDTransactionChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IDProductDetails", DbType="Int")]
	public System.Nullable<int> IDProductDetails
	{
		get
		{
			return this._IDProductDetails;
		}
		set
		{
			if ((this._IDProductDetails != value))
			{
				if (this._ProductDetail.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.OnIDProductDetailsChanging(value);
				this.SendPropertyChanging();
				this._IDProductDetails = value;
				this.SendPropertyChanged("IDProductDetails");
				this.OnIDProductDetailsChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Qty", DbType="Int")]
	public System.Nullable<int> Qty
	{
		get
		{
			return this._Qty;
		}
		set
		{
			if ((this._Qty != value))
			{
				this.OnQtyChanging(value);
				this.SendPropertyChanging();
				this._Qty = value;
				this.SendPropertyChanged("Qty");
				this.OnQtyChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Price", DbType="Int")]
	public System.Nullable<int> Price
	{
		get
		{
			return this._Price;
		}
		set
		{
			if ((this._Price != value))
			{
				this.OnPriceChanging(value);
				this.SendPropertyChanging();
				this._Price = value;
				this.SendPropertyChanged("Price");
				this.OnPriceChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Discount", DbType="Int")]
	public System.Nullable<int> Discount
	{
		get
		{
			return this._Discount;
		}
		set
		{
			if ((this._Discount != value))
			{
				this.OnDiscountChanging(value);
				this.SendPropertyChanging();
				this._Discount = value;
				this.SendPropertyChanged("Discount");
				this.OnDiscountChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Subtotal", DbType="Int")]
	public System.Nullable<int> Subtotal
	{
		get
		{
			return this._Subtotal;
		}
		set
		{
			if ((this._Subtotal != value))
			{
				this.OnSubtotalChanging(value);
				this.SendPropertyChanging();
				this._Subtotal = value;
				this.SendPropertyChanged("Subtotal");
				this.OnSubtotalChanged();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="ProductDetail_TransactionDetail", Storage="_ProductDetail", ThisKey="IDProductDetails", OtherKey="IDProductDetails", IsForeignKey=true)]
	public ProductDetail ProductDetail
	{
		get
		{
			return this._ProductDetail.Entity;
		}
		set
		{
			ProductDetail previousValue = this._ProductDetail.Entity;
			if (((previousValue != value) 
						|| (this._ProductDetail.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._ProductDetail.Entity = null;
					previousValue.TransactionDetails.Remove(this);
				}
				this._ProductDetail.Entity = value;
				if ((value != null))
				{
					value.TransactionDetails.Add(this);
					this._IDProductDetails = value.IDProductDetails;
				}
				else
				{
					this._IDProductDetails = default(Nullable<int>);
				}
				this.SendPropertyChanged("ProductDetail");
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Transaction_TransactionDetail", Storage="_Transaction", ThisKey="IDTransaction", OtherKey="IDTransaction", IsForeignKey=true)]
	public Transaction Transaction
	{
		get
		{
			return this._Transaction.Entity;
		}
		set
		{
			Transaction previousValue = this._Transaction.Entity;
			if (((previousValue != value) 
						|| (this._Transaction.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._Transaction.Entity = null;
					previousValue.TransactionDetails.Remove(this);
				}
				this._Transaction.Entity = value;
				if ((value != null))
				{
					value.TransactionDetails.Add(this);
					this._IDTransaction = value.IDTransaction;
				}
				else
				{
					this._IDTransaction = default(Nullable<int>);
				}
				this.SendPropertyChanged("Transaction");
			}
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
}
#pragma warning restore 1591
